------------------------------------------------------------------
--FCOMounter.lua
--Author: Baertram
--v0.0.1
--[[
React on mounting a mount
]]
------------------------------------------------------------------
--Array for all the variables
local locVars = {}
locVars.AddMessage_Orig = nil

--Addon variables
local addonVars = {}
addonVars.gAddonName				= "FCO|cFFFF00Mounter|r"
addonVars.addonAuthor 				= '|cFFFF00Baertram|r'
addonVars.addonVersion		   		= 0.01 -- Changing this will reset SavedVariables!
addonVars.addonVersionOptions 		= '0.0.1' -- version shown in the settings panel
addonVars.addonSavedVariablesName	= "FCOMounter_Settings"

local settingsVars = {}
settingsVars.settings = {}
settingsVars.defaults = {}

--==============================================================================
--==================== START EVENT CALLBACK FUNCTIONS===========================
--==============================================================================

--Show a help inside the chat
local function help()
    local mountWeaponBar = "Disabled"
    if settingsVars.settings.onMountSwitchActionBarTo ~= 0 then mountWeaponBar = settingsVars.settings.onMountSwitchActionBarTo end
    local unmountWeaponBar = "Disabled"
    if settingsVars.settings.onUnMountSwitchActionBarTo ~= 0 then unmountWeaponBar = settingsVars.settings.onUnMountSwitchActionBarTo end
    d("[FCOMounter] React on mounting a mount")
    d(">> Current mount weapon bar: " .. mountWeaponBar )
    d(">> Current unmount weapon bar: " .. unmountWeaponBar)
    d("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
    d("This addon is able to change your weapon bar id to a desired number (1 or 2) if you mount.")
    d("\nATTENTION: This will only work if you use the unofficial ESOLauncher (Graphics Enhancer) from www.Gamemodi.net!")
    d(">> Type /fcom id <ID> to change the weapon bar ID the game should switch to, if you mount")
    d(">> Type /fcom unmountid <ID> to change the weapon bar ID the game should switch to, if you unmount")
    d("<ID> can be 1 or 2 and is your desired weapon bar id, or 0 to disable it!")
end

--Check the commands ppl type to the chat
local function command_handler(args)
    --Parse the arguments string
    local options = {}
    local searchResult = { string.match(args, "^(%S*)%s*(.-)$") }
    for i,v in pairs(searchResult) do
        if (v ~= nil and v ~= "") then
            options[i] = string.lower(v)
        end
    end

    if(#options == 0 or options[1] == "" or options[1] == "help" or options[1] == "hilfe" or options[1] == "list") then
        help()
    elseif(options[1] == "id") then
        if options[2] ~= "0" and options[2] ~= "1" and options[2] ~= "2" then
            d("[FCOMounter - ERROR] Please enter only 1 or 2")
    else
        settingsVars.settings.onMountSwitchActionBarTo = tonumber(options[2])
        local newMountWeaponBarId = "Disabled"
        if settingsVars.settings.onMountSwitchActionBarTo ~= 0 then newMountWeaponBarId = settingsVars.settings.onMountSwitchActionBarTo end
        d("[FCOMounter] Changed mount weapon bar to: " .. newMountWeaponBarId)
        end
    elseif(options[1] == "unmountid") then
        if options[2] ~= "0" and options[2] ~= "1" and options[2] ~= "2" then
            d("[FCOMounter - ERROR] Please enter only 1 or 2")
        else
            settingsVars.settings.onUnMountSwitchActionBarTo = tonumber(options[2])
            local newUnMountWeaponBarId = "Disabled"
            if settingsVars.settings.onUnMountSwitchActionBarTo ~= 0 then newUnMountWeaponBarId = settingsVars.settings.onUnMountSwitchActionBarTo end
            d("[FCOMounter] Changed unmount weapon bar to: " .. newUnMountWeaponBarId)
        end
    end
end


--Register the slash commands
local function RegisterSlashCommands()
    -- Register slash commands
    SLASH_COMMANDS["/fcomounter"] = command_handler
    SLASH_COMMANDS["/fcom"]		  = command_handler
end

--callback function for the OnMountStateChanged event
local function FCOMounter_OnMountStateChanged(eventCode, isMounted)
    zo_callLater(function()
        --d("Drin mounted state change to: ".. tostring(isMounted) .. ", Active weapon pair info: " .. GetActiveWeaponPairInfo() .. ", Desired ID: " .. settingsVars.settings.onMountSwitchActionBarTo)
        --Mounted?
        if isMounted then
            --Change the weapon bars if they are not already at the desired bar
            if settingsVars.settings.onMountSwitchActionBarTo ~= 0 and GetActiveWeaponPairInfo() ~= settingsVars.settings.onMountSwitchActionBarTo then
                OnSpecialMoveKeyPressed(SPECIAL_MOVE_INDEX_WEAPON_SWAP)
            end
        else
            --Change the weapon bars if they are not already at the desired bar
            if settingsVars.settings.onUnMountSwitchActionBarTo ~= 0 and GetActiveWeaponPairInfo() ~= settingsVars.settings.onUnMountSwitchActionBarTo then
                OnSpecialMoveKeyPressed(SPECIAL_MOVE_INDEX_WEAPON_SWAP)
            end
        end
    end, 50)
end

-- Fires each time after addons were loaded and player is ready to move (after each zone change too)
local function FCOMounter_Player_Activated(...)
    EVENT_MANAGER:RegisterForEvent(addonVars.gAddonName, EVENT_MOUNTED_STATE_CHANGED, FCOMounter_OnMountStateChanged)
end

local function  FCOMounter_Addon_Loaded(eventCode, addOnName)
	--Is THIS addon HERE found?
    if(addOnName ~= "FCOMounter") then
        return
    end

    --Pre-set the deafult values
    settingsVars.defaults = {
        --language 	 		    	= 1, --Standard: English
        --saveMode     		    	= 2, --Standard: Account wide settings
        languageChoosen				= false,
        onMountSwitchActionBarTo    = 0,
        onUnMountSwitchActionBarTo    = 0,
    }

    --=============================================================================================================
    --	LOAD USER SETTINGS
    --=============================================================================================================
    settingsVars.settings = ZO_SavedVars:New(addonVars.addonSavedVariablesName, addonVars.addonVersion , "Settings", settingsVars.defaults )
    --=============================================================================================================

    --If you got here your addon is found so execute the following code lines:
    --Unregister this event again so it isn't fired again after this addon has beend loaded
    EVENT_MANAGER:UnregisterForEvent(addonVars.gAddonName, EVENT_ADD_ON_LOADED)
	--Register for the zone change/player ready event
	EVENT_MANAGER:RegisterForEvent(addonVars.gAddonName, EVENT_PLAYER_ACTIVATED, FCOMounter_Player_Activated)

    --Register the chat commands
    RegisterSlashCommands()
end

-- Register the event "addon loaded" for this addon
local function FCOMounter_Initialized()
	--Register for the addon loaded
	EVENT_MANAGER:RegisterForEvent(addonVars.gAddonName, EVENT_ADD_ON_LOADED, FCOMounter_Addon_Loaded)
end

--------------------------------------------------------------------------------
--- Call the start function for this addon to register events etc.
--------------------------------------------------------------------------------
FCOMounter_Initialized()
